/**
 * Programa   : Ferramenta AutoSSH para servir de apoio a Ferramenta SVarLog do SAESD, para login automtico
 * em servidores linux por meio do uso do protocolo Secure Shell, atravs do gerenciamento de chaves assimtricas
 * Objetivo: Logar automaticamente em servidores Linux pelo protocolo SSH, realizar o processo de automao nas diferentes verses do SSH.
 * Programador: Alessandro Dutra de Andrade - RGM: 022693
 * Data: 20/09/2016
 */
 /*atribu um o valor para cada verso do protoco SSH para identificar o tipo de conexo que seria estabelecida
    SSH1    = 1
    SSH2    = 2
    OPENSSH = 3
    onde poderemos obter as seguintes combinaes
    cliente     servidor     combinaes
    SSH1          SSH1          11
    SSH1          SSH2          12
    SSH1        OPENSSH         13
    SSH2          SSH2          22
    SSH2          SSH1          21
    SSH2        OPENSSH         23
    OPENSSH     OPENSSH         33
    OPENSSH       SSH1          31
    OPENSSH       SSH2          32

    Apartir dessa idia foi criada as seguintes definies
    #define SSH1_PARA_SSH1 11
    #define SSH1_PARA_SSH2 12
    #define SSH1_PARA_OPENSSH 13
    #define SSH2_PARA_SSH2 22
    #define SSH2_PARA_SSH1 21
    #define SSH2_PARA_OPENSSH 23
    #define OPENSSH_PARA_OPENSSH 33
    #define OPENSSH_PARA_SSH1 31
    #define OPENSSH_PARA_SSH2 32
*/

#include <windows.h>/*sleep(); DeleteFile(); */
#include <Winbase.h>/*CreateProcess()*/
#include <shellapi.h>/*ShellExecute()*/
#include <stdio.h>/*sprintf(); printf () ; switch(); */
#include <stdlib.h>/*system();*/
#include <string.h>/*strlen();*/
#include <time.h>/*_strdate(); _strtime()*/
#include <ctype.h>/*toupper(); */
#define TAMANHO 255
#ifndef __AUTO_SSH_H__
#define __AUTO_SSH_H__
#define SSH1_PARA_SSH1 11
#define SSH1_PARA_SSH2 12
#define SSH1_PARA_OPENSSH 13
#define SSH2_PARA_SSH2 22
#define SSH2_PARA_SSH1 21
#define SSH2_PARA_OPENSSH 23
#define OPENSSH_PARA_OPENSSH 33
#define OPENSSH_PARA_SSH1 31
#define OPENSSH_PARA_SSH2 32

typedef struct {
	char Servidor[TAMANHO];
	char Usuario[TAMANHO];
	char Comando[TAMANHO];
	char VerCliente[TAMANHO];
	char VerServidor[TAMANHO];
	char LigacaoSimbolica[TAMANHO];
} AUTO_SSH;

/*prototipao das funes usadas pelo programa*/
/*void TestaConexaoInternet();*/
void Inicializacao(int, char **);
void Cria_Arquivo();
int gera_autenticacao(AUTO_SSH, char *);
void restaura_ip(char *);
int ExecutaComando(char *);
void ApagaChaveAutenticacao();
/*int ExecutaComandoElevado(char *);*/
int CriaProcesso(char *);
void DeletaArquivo(char *);
void GetUsuario(char *);
/*funcoes para trabalhar com registro do windows*/
int CriaRegistro(char *);
int BuscaRegistro(char *);
int AdicionaValorChave(char *, char *, char *);
AUTO_SSH LerRegistroSSH(char *);
char *strTrim(char *);
char *RetiraCaracter(char *, char);
char *ToUpper(char *);
void ProcessaSaida(AUTO_SSH ParamSSH);

#endif /*__AUTO_SSH_H__*/
